// ****************************************************************************
//                               h5partPluginInfo.h
// ****************************************************************************

#ifndef H5PART_PLUGIN_INFO_H
#define H5PART_PLUGIN_INFO_H
#include <DatabasePluginInfo.h>
#include <database_plugin_exports.h>

class avtDatabase;
class avtDatabaseWriter;

// ****************************************************************************
//  Class: h5partDatabasePluginInfo
//
//  Purpose:
//    Classes that provide all the information about the h5part plugin.
//    Portions are separated into pieces relevant to the appropriate
//    components of VisIt.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 9 09:51:18 PDT 2006
//
//  Modifications:
//
// ****************************************************************************

class h5partGeneralPluginInfo : public virtual GeneralDatabasePluginInfo
{
public:
	virtual char *GetName() const;
	virtual char *GetVersion() const;
	virtual char *GetID() const;
	virtual bool  EnabledByDefault() const;
	virtual bool  HasWriter() const;
};

class h5partCommonPluginInfo : public virtual CommonDatabasePluginInfo, public virtual h5partGeneralPluginInfo
{
public:
	virtual DatabaseType              GetDatabaseType();
	virtual std::vector<std::string>  GetDefaultExtensions();
	virtual avtDatabase              *SetupDatabase(const char * const *list,
	                                                int nList, int nBlock);
};

class h5partMDServerPluginInfo : public virtual MDServerDatabasePluginInfo, public virtual h5partCommonPluginInfo
{
public:
	// this makes compilers happy... remove if we ever have functions here
	virtual void dummy();
};

class h5partEnginePluginInfo : public virtual EngineDatabasePluginInfo, public virtual h5partCommonPluginInfo
{
public:
	virtual avtDatabaseWriter        *GetWriter(void);
};

#endif
